<?php
/**
 * [Core]Access：アクセス解析処理クラス
 * アクセス時の情報を解析して返却する
 *
 * @link http://komaphp.k-akimoto-matsu.net/Reference#subtitle0 リファレンス@Core.Access
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
class Access{

	/**
	 * ユーザエージェントを解析して返す
	 * @param unknown $us
	 * @return string
	 * @return NULL[]|unknown[]|string[][]|unknown[][]|NULL[][]|string[]
	 */
	public static function ua($us=null){
		if(is_null($us)) return [];

		# OSをSearch
		$oslist = Config::get("accesslist","oslist");
		$os_disp = null;
		$os_sw = null;
		foreach($oslist as $os=>$list){
			if(!is_null($os_disp)) break;
			if($os == "win"){
				foreach($list as $searchw=>$dispname){
					if(preg_match('/'.$searchw.'/',$us)){
						$os_disp = $dispname;
						$os_sw = $searchw;
						break;
					}
				}
			}else{
				foreach($list as $searchw=>$dispname){
					if(preg_match('/'.$searchw.'/',$us,$matches)){
						if($os=="mac" || $os=="iOS"){
							$os_disp = $dispname.str_replace("_",".",$matches[1]);
							$os_sw = $searchw;
							break;
						}else{
							$os_disp = $dispname.$matches[1];
							$os_sw = $searchw;
							break;
						}
					}
				}
			}
		}

		$browserlist = Config::get("accesslist","browserlist");
		$br_disp = null;
		$br_sw = null;
		foreach($browserlist as $bs=>$list){
			if(!is_null($br_disp)) break;
			if($bs == "major"){
				foreach($list as $searchw=>$dispname){
					if(preg_match('/'.$searchw.'/',$us,$matches)){
						if($dispname == "Internet Explorer" || $dispname=="Opera"){
							$br_disp = $dispname." ".$matches[2];
							$br_sw = $searchw;
						}else{
							$br_disp = $dispname." ".$matches[1];
							$br_sw = $searchw;
						}
						break;
					}
				}
			}elseif($bs == "minor"){ //and bot
				foreach($list as $searchw){
					if(preg_match('/'.$searchw.'/',$us,$matches)){
						$br_disp = $matches[1]." ".$matches[2];
						$br_sw = $searchw;
						break;
					}
				}
			}elseif($bs == "game"){
				foreach($list as $searchw=>$dispname){
					if(preg_match('/'.$searchw.'/',$us,$matches)){
						$br_disp = $dispname." ".$matches[1];
						$br_sw = $searchw;
						break;
					}
				}
			}elseif($bs == "bot"){
				foreach($list as $searchw=>$dispname){
					if(preg_match('/'.$searchw.'/',$us,$matches)){
						$br_disp = $dispname." ".$matches[1];
						$br_sw = $searchw;
						break;
					}
				}
			}
		}

		$devicelist = Config::get("accesslist","devicelist");
		$dv_disp = "PC";
		$dv_sw = "pc";
		foreach($devicelist as $searchw=>$dispname){
			if(preg_match('/'.$searchw.'/',$us)){
				$dv_disp = $dispname;
				$dv_sw = $searchw;
				break;
			}
		}
		//disp=表示用 sw=検索用
		$ret["os"] = ["disp"=>$os_disp,"sw"=>$os_sw];
		$ret["browser"] =  ["disp"=>$br_disp,"sw"=>$br_sw];
		$ret["device"] = ["disp"=>$dv_disp,"sw"=>$dv_sw];

		return $ret;
	}

}