<?php
/**
 * [Core]Html：Html処理クラス
 * Html生成に関する機能
 *
 * @link http://komaphp.k-akimoto-matsu.net/Reference#subtitle0 リファレンス@Core.Html
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
class Html{

	/**
	 * a リンク
	 * @param string $href リンク先
	 * @param string $linkName 文言
	 * @param array $args
	 * @param boolean $on true:サイト内 false:外部
	 * @return string
	 */
	public static function link($href="",$linkName="link",$args =[],$on=true){
		$option = null;
		if(count($args) > 0){
			foreach( $args as $k => $v ){
				$option .= " {$k}=\"$v\" ";
			}
		}
		if($on){
			return "<a href=\"".Config::get("app","httproot")."{$href}\" {$option}>{$linkName}</a>\n";
		}else{
			return "<a href=\"{$href}\" {$option}>{$linkName}</a>\n";
		}
	}

	/**
	 * textarea系のコメントをWEBに表示できる形式にして返す
	 * @param string $value 対象文字列
	 * @param string $f htmlエスケープをするかどうか
	 * @return mixed
	 */
	public static function tAreaForDisp($value="",$f=false){
		$comment = "";
		if($f){
			$comment = str_replace(" ","&nbsp;",self::hsp($value));
		}else{
			$comment = $value;
		}
		$comment = str_replace("\t","&nbsp;&nbsp;&nbsp;&nbsp;",$comment);
		$comment = str_replace(["\r\n","\n"],"<br />",$comment);
		return $comment;
	}

	/**
	 * htmlspecialchars
	 * @param string $value
	 * @return string
	 */
	public static function hsp($value=""){
		if(is_array($value)) return $value; //配列は処理せずそのまま返す
		return htmlentities($value, ENT_QUOTES, 'UTF-8');
	}

}
