<?php
/**
 * [View]template/listtemplate：一覧表示テンプレート
 * 検索結果一覧HTMLを出力
 *
 * @param $conName ：fwcore/Config/listの一覧名（必須）
 * @param $param["list"] ：表示用データ（任意）：Controllerよりparam["list"]を設定する
 * @link http://komaphp.k-akimoto-matsu.net/Manual#subtitle8 マニュアル@ビュー.template/listtemplate
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
$listconfig = Config::get("list",$conName);

//一覧設定は必須
if(is_null($listconfig)){
	return null;
}
$html=null;

if(!isset($listCss)){
	$listCss = null;
}

//初期表示ありなし　trueの場合はリストを初期表示しない
if(!isset($initialDisplay)){
	$initialDisplay = true;
}

//画面初期表示がない場合の表示
if(!$initialDisplay && Session::get($conName) == null){

	return "<p>".Config::get("message","initialnolist")."</p>\n";
}else{

	//検索結果で一覧情報がない場合の表示
	if(Helper::ak("list", $param) && count($param["list"]) == 0){

		return "<p>".Config::get("message","nolist")."</p>\n";

	}else{
		//ページング結果のリスト取得
		if($pager){
			if(!isset($page)){
				$page = 1;
			}
			$pHtml = Pager::pagerHtml($page,count($param["list"]),$conName);
			$param["list"] = Pager::thisPageList($param["list"],$page);
			if(count($param["list"]) == 0){
				return "<p>".Config::get("message","nolist")."</p>\n";
			}
		}

		if(isset($pHtml)){
			$html .= $pHtml;
		}

		$html .= "<table id=\"{$conName}Form\" class=\"listForm {$listCss}\">\n";
		$html .= "\t<tr>\n";
		foreach($listconfig as $k=>$v){
			$width = null;
			//ボタンの幅は固定する
			if($v["type"] == "button"){
				$v["width"] = "80px";
			}
			if(Helper::ak("width",$v)){
				$width = " style=\"width:{$v["width"]}!important;\"";
			}
			$html .= "\t\t<th id=\"{$k}Head\"{$width}>\n";
			$html .= "\t\t{$v["label"]}\n";
			//ソート設定あるか
			if(Helper::ak("sort",$v) && $v["sort"]){
				$html .= Html::link($conName."?".$k."=0","▲",["class"=>"sort"]);
				$html .= Html::link($conName."?".$k."=1","▼",["class"=>"sort"]);
			}
			$html .= "\t\t</th>\n";
		}
		$html .= "\t</tr>\n";

		foreach ($param["list"] as $rownum=>$rowdata){
			$html .= "\t<tr>\n";
			foreach($listconfig as $k=>$v){
				$setting = [];
				if(Helper::ak("setting",$v) ){
					$setting = $v["setting"];
				}

				$html .= "\t\t<td id=\"{$k}Row{$rownum}\">\n";
				$rData = '';
				if(Helper::ak($k, $rowdata)){
					$rData = Html::hsp($rowdata[$k]);
				}

				//ページ別対応
				//データを空白表示にする
				if(Helper::ak("blank",$v)){
					$binfoAr = explode("=",$v["blank"]);
					$binfotarget = explode(",",$binfoAr[1]);
					if(in_array($rowdata[$binfoAr[0]],$binfotarget)){
						$rData = null;
					}
				}

				//タイプによる表示形態
				$type=null;
				$link=null;
				switch($v["type"]){
					case 'select':
						if(Helper::ak("select", $v)){
							$type = Config::get("type",$v["select"]);
							if(!is_null($type)){

								//入力フィールドを表示する
								if(Helper::ak("input",$v) && $v["input"]){
									$rData = Form::select("{$k}_{$rownum}",$type,$rData,$setting);
								}else{
									if(Helper::ak($rData, $type)){
										$rData = $type[$rData];
									}else{
										$rData = "";
									}
								}
							}

						}
						break;
					case 'date':
						if(Helper::ak("format", $v) && (!is_null($rData) && trim($rData) != "")){
							$rData = date($v["format"],strtotime($rData));
						}
						if(Helper::ak("input",$v) && $v["input"]){
							$rData = Form::text("{$k}_{$rownum}",$rData,$setting);
						}
						break;
					case 'db':
						if(Helper::ak("select", $v)){
							$t = explode("-", $v["select"]);
							$mo = DbModel::read($t[0]);
							$lis = $mo->getInfoByID($rData);

							//入力フィールドを表示する
							if(Helper::ak("input",$v) && $v["input"]){
								$rData = Form::select("{$k}_{$rownum}",$lis,$rData,$setting);
							}else{
								if(Helper::ak($t[1],$lis)){
									$rData = Html::hsp($lis[$t[1]]);
								}else{
									$rData = null;
								}
							}
						}
						break;
					case 'button':
						$bname = "ボタン";
						if(Helper::ak("name",$v)){
							$bname = $v["name"];
						}
						$link = null;
						if(Helper::ak("link", $v)){
							$link = $v["link"];
						}

						$targetnum = 0;
						preg_match_all("/\#.+?\#/",$link,$match);
						if(count($match[0]) > 0){
							foreach($match[0] as $mtnum=>$mtnumval){
								if($mtnum == 0){
									$tarnum = "";
								}else{
									$tarnum = $mtnum;
								}
								$tarname = "target".$tarnum;
								${$tarname} = str_replace("#","",$match[0][$mtnum]);
								$targetnum++;
							}
						}

						$act = "link";
						if(Helper::ak("action",$v)){
							$act = $v["action"];
						}

						//設定により表示を変える
						//options
						$options = ["class"=>"edit","id"=>$k.$rownum];

						if($k == "Delete" || $k == "delete" || $k == "Del" || $k == "del"){
							$options["class"] .= " delete";
						}
						if($k == "Update" || $k == "update" || $k == "Up" || $k == "up"){
							$options["class"] .= " post";
						}

						if(Helper::ak("js", $v)){
							$js =$v["js"];
							preg_match_all("/\#.+?\#/",$js,$match);
							if(count($match[0]) > 0){
								foreach($match[0] as $mtnum=>$mtnumval){
									if($mtnum == 0){
										$tarnum = "";
									}else{
										$tarnum = $mtnum;
									}
									$tarname = "target".$tarnum;
									${$tarname} = str_replace("#","",$match[0][$mtnum]);
									if(!is_null(${$tarname})){
										if(Helper::ak(${$tarname},$rowdata)){
											$js = str_replace("#{${$tarname}}#",$rowdata[${$tarname}],$js);
										}
									}
								}
							}

							preg_match("/\[.+?\]/",$v["js"],$match);
							$othertar = null;
							if(count($match)>0){
								$othertar = str_replace("[","",$match[0]);
								$othertar = str_replace("]","",$othertar);
							}

							if(!is_null($othertar)){
								if(Helper::ak($othertar,$rowdata)){
									$js = str_replace("[{$othertar}]",$rowdata[$othertar],$js);
								}
							}
							//rownum
							$js = str_replace("@rownum@",$rownum,$js);

							$options = array_merge($options,["onClick"=>$js]);
						}

						switch($act){
							//遷移
							case "link":
								for($trnum=0;$trnum<$targetnum;$trnum++){
									if($trnum == 0){
										$tnum = "";
									}else{
										$tnum = $trnum;
									}
									$tarname = "target".$tnum;
									$link = str_replace("#{${$tarname}}#",Helper::urlen($rowdata[${$tarname}]),$link); //リンク遷移はURLエンコードかける
								}
								$rData = Html::link($link,$bname,$options);
								break;
							//ajaxで何かしら実行するタイプ
							case "ajax":
								$rData = Html::link("javascript:void(0);",$bname,$options,false);
								break;
						}

						break;
					//icon表示
					case "icon":
						$disp = true;
						if(Helper::ak("data",$v)){
							if($v["data"] && (!is_null($rData) && trim($rData) != "")){

							}else{
								$disp = false;
							}
						}
						if($disp){
							$i_name = "edit";
							if(Helper::ak("i_name",$v)){
								$i_name = $v["i_name"];
							}
							$i_alt = "編集中";
							if(Helper::ak("i_alt",$v)){
								$i_alt = $v["i_alt"];
							}
							$rData = "<img src=\"{$root}Include/image/imagelist".Config::get("app","dir")."{$i_name}.png\" alt=\"{$i_alt}\" title=\"{$i_alt}\" width=\"16px\">";
							if(Helper::ak("click",$v)){
								$js = null;
								preg_match_all("/\#.+?\#/",$v["click"],$match);
								if(count($match[0]) > 0){
									foreach($match[0] as $mtnum=>$mtnumval){
										if($mtnum == 0){
											$tarnum = "";
										}else{
											$tarnum = $mtnum;
										}
										$tarname = "target".$tarnum;
										${$tarname} = str_replace("#","",$match[0][$mtnum]);

										if(!is_null(${$tarname})){
											if(Helper::ak(${$tarname},$rowdata)){
												$js = str_replace("#{${$tarname}}#",$rowdata[${$tarname}],$v["click"]);
											}
										}
									}
								}
								$rData = "<a href=\"javascript:void(0);\" onClick=\"{$js}\">{$rData}</a>";
							}
						}
						break;
					case "span":
						$rData = "<span id=\"{$k}_{$rownum}\">{$rData}</span>";
						break;
					default:
						//入力有り？
						if(Helper::ak("input",$v) && $v["input"]){
							if(Helper::ak("inputtype",$v)){
								$rData = Form::$v["inputtype"]("{$k}_{$rownum}",$rData,$setting);
							}else{
								$rData = Form::text("{$k}_{$rownum}",$rData,$setting);
							}
						}
				}

				$html .= "\t\t{$rData}\n";

				$html .= "\t\t</td>\n";
			}
			$html .= "\t</tr>\n";
		}

		$html .= "</table>\n";

		if(isset($pHtml)){
			$html .= "<div class=\"spacer10\"></div>\n";
			$html .= $pHtml;
		}

		return $html;
	}
}
